;;; Studio Tecnico Arch. Giuseppe Conte  
;;; via Roma, 28
;;; 72026 - San Pancrazio Salentino (BR) - Italy
;;;
;;; Plugin  : polygonal-selection.scm
;;; Author  : Arch. Giuseppe Conte 
;;; Date    : 21 gennaio 2003 - San Pancrazio Salentino (BR) - Italy
;;; Revision: 16 marzo 2008  update to TinyScheme
;;; Version : 2.4
;;; Last version at: http://xoomer.alice.it/lwcon/gimp/script-fu/poligonal-selection.htm
;;; Help guide at  : http://xoomer.alice.it/lwcon/gimp/script-fu/poligonal-selection.htm
;;; Required : Gimp 2.4 or last
;;;
;;; Description: 
;;; Polygonal selection carefully places a regular polygon selection of the user-specified 
;;; radius and sides at the user-specified coordinates of center.
;;; -----------------------------------------------------------------------------
;;;
;;; License:
;;; This program is free software; you can redistribute it and/or modify
;;; it under the terms of the GNU General Public License as published by
;;; the Free Software Foundation; either version 2 of the License, or
;;; (at your option) any later version.
;;; 
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;; 
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

;;; Define the function:

(define (script-fu-polygonal-selection inImage inLayer dx dy Radius Lati Rotaz)

	(let* (	(angolo)
					(arco)
					(aRotaz)
					(beta) 
					(gamma) 
					(gcount) 
					(npoint (* Lati 2))
					(j) 
					(k)
					(segment)
					(segment (make-vector npoint))
					(stepx) 
					(stepy) 
					(raggio) 
					(nlati)
				)
    
		(set! angolo (/ 360 Lati))
		(set! arco (* angolo (/ 3.14 180)))
		(set! aRotaz (* Rotaz (/ 3.14 180)))
;		(set! beta aRotaz)
		(set! gamma aRotaz)
		(set! gcount 1)
		(set! j 0)
		(set! k 1)
		(set! stepx dx)
		(set! stepy dy)
		(set! raggio Radius)
		(set! nlati Lati)

  ;(gimp-message "Ci sono")
  
  (while (<= gcount nlati) 
  	
     	(vector-set! segment j (+ (* raggio (cos gamma)) stepx))
  		(vector-set! segment k (+ (- (* raggio (sin gamma))) stepy))  		
  		(set! gamma (+ gamma arco))  	  		 
			(set! j (+ j 2))
			(set! k (+ k 2))  
  		(set! gcount (+ gcount 1))
   	
   );end while

    (gimp-free-select inImage npoint segment REPLACE TRUE FALSE 0)    
    
	  (gimp-displays-flush)
  
 );;let
) ;;def

(script-fu-register
 "script-fu-polygonal-selection"
 _"<Image>/_ATG/_Selection/P_olygonal selection"
 "Polygonal selection carefully places a regular polygon selection\ of the user-specified radius and sides at the user-specified\ coordinates of center."
 "Arch. Giuseppe Conte <http://space.tin.it/edicola/lwcon/>"
 "2008, Giuseppe Conte"
 "16 marzo 2008 - San Pancrazio Salentino (BR) - Italy"
 "RGB* GRAY* INDEXED*"
 SF-IMAGE "The Image" 0
 SF-DRAWABLE "The Layer" 0
 SF-ADJUSTMENT "X center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Y center" '(0 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Radius" '(10 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Numero di Lati" '(3 0 9999 1 10 0 1)
 SF-ADJUSTMENT "Inclinazione" '(0 -9999 9999 1 10 0 1)
)
